<?php

declare(strict_types=1);

namespace Drupal\migrate_dc\Plugin\migrate\source;

use Drupal\migrate\Attribute\MigrateSource;
use Drupal\migrate\Plugin\MigrationInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Reads source from a Yaml file.
 */
#[MigrateSource(
  id: 'migrate_dc_yaml',
)]
class MigrateDcYamlSource extends MigrateDcJsonSource {

  /**
   * {@inheritdoc}
   *
   * @phpstan-param array<string, mixed> $configuration
   * @phpstan-param string $plugin_id
   * @phpstan-param array<string, mixed> $plugin_definition
   */
  public static function create(
    ContainerInterface $container,
    array $configuration,
    $plugin_id,
    $plugin_definition,
    ?MigrationInterface $migration = NULL,
  ): static {
    // @phpstan-ignore-next-line
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition,
      $migration,
      $container->get('serialization.yaml'),
    );
  }

}
