<?php

declare(strict_types=1);

namespace Drupal\Tests\migrate_dc\Unit\Plugin\migrate\source;

use Drupal\Component\Serialization\Yaml;
use Drupal\migrate\Plugin\MigrateSourceInterface;
use Drupal\migrate\Plugin\MigrationInterface;
use Drupal\migrate_dc\Plugin\migrate\source\MigrateDcYamlSource;
use PHPUnit\Framework\Attributes\CoversClass;
use PHPUnit\Framework\Attributes\Group;
use Symfony\Component\DependencyInjection\ContainerInterface;

#[Group('migrate_dc')]
#[CoversClass(MigrateDcYamlSource::class)]
class MigrateDcYamlSourceTest extends MigrateDcJsonSourceTest {

  protected static string $serializerClass = Yaml::class;

  /**
   * @phpstan-param array<string, mixed> $configuration
   */
  protected function createInstance(array $configuration): MigrateSourceInterface {
    $pluginId = 'migrate_dc_yaml';
    $pluginDefinition = [];

    /** @var \Drupal\migrate\Plugin\MigrationInterface&\PHPUnit\Framework\MockObject\MockObject $migration */
    $migration = $this->createMock(MigrationInterface::class);

    /** @var \Symfony\Component\DependencyInjection\ContainerInterface&\PHPUnit\Framework\MockObject\MockObject $container */
    $container = $this->createMock(ContainerInterface::class);
    $container
      ->method('get')
      ->with('serialization.yaml')
      ->willReturn($this->getSerializer());

    return MigrateDcYamlSource::create(
      $container,
      $configuration,
      $pluginId,
      $pluginDefinition,
      $migration,
    );
  }

}
